=== modified file 'chardet/__init__.py'
--- chardet/__init__.py	2006-07-08 16:12:00 +0000
+++ chardet/__init__.py	2008-03-05 20:26:06 +0000
@@ -15,7 +15,7 @@
 # 02110-1301  USA
 ######################### END LICENSE BLOCK #########################
 
-__version__ = "1.0"
+__version__ = "1.0.1"
 
 def detect(aBuf):
     import universaldetector

=== modified file 'chardet/escsm.py'
--- chardet/escsm.py	2006-07-08 16:12:00 +0000
+++ chardet/escsm.py	2008-03-05 20:26:06 +0000
@@ -180,7 +180,7 @@
 eError,eError,eError,eError,eItsMe,eError,eStart,eStart,# 40-47 
 )
 
-ISO2022JPCharLenTable = (0, 0, 0, 0, 0, 0, 0, 0)
+ISO2022JPCharLenTable = (0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
 
 ISO2022JPSMModel = {'classTable': ISO2022JP_cls,
                     'classFactor': 10,

=== modified file 'chardet/universaldetector.py'
--- chardet/universaldetector.py	2006-07-08 16:12:00 +0000
+++ chardet/universaldetector.py	2008-03-05 20:26:06 +0000
@@ -81,7 +81,7 @@
             elif aBuf[:4] == '\x00\x00\xFF\xFE':
                 # 00 00 FF FE  UCS-4, unusual octet order BOM (2143)
                 self.result = {'encoding': "X-ISO-10646-UCS-4-2143", 'confidence': 1.0}
-            elif aBuf[:4] == '\xFF\xFE':
+            elif aBuf[:2] == '\xFF\xFE':
                 # FF FE  UTF-16, little endian BOM
                 self.result = {'encoding': "UTF-16LE", 'confidence': 1.0}
             elif aBuf[:2] == '\xFE\xFF':

=== modified file 'docs/css/chardet.css' (properties changed: +x to -x)
=== modified file 'docs/faq.html'
--- docs/faq.html	2006-07-08 16:12:00 +0000
+++ docs/faq.html	2008-03-05 20:26:06 +0000
@@ -1,107 +1,107 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
-<html lang="en">
-<head>
-<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<title>Frequently asked questions [Universal Encoding Detector]</title>
-<link rel="stylesheet" href="css/chardet.css" type="text/css">
-<link rev="made" href="mailto:mark@diveintomark.org">
-<meta name="generator" content="DocBook XSL Stylesheets V1.65.1">
-<meta name="keywords" content="character, set, encoding, detection, Python, XML, feed">
-<link rel="start" href="index.html" title="Documentation">
-<link rel="up" href="index.html" title="Documentation">
-<link rel="prev" href="index.html" title="Documentation">
-<link rel="next" href="supported-encodings.html" title="Supported encodings">
-</head>
-<body id="chardet-feedparser-org" class="docs">
-<div class="z" id="intro"><div class="sectionInner"><div class="sectionInner2">
-<div class="s" id="pageHeader">
-<h1><a href="/">Universal Encoding Detector</a></h1>
-<p>Character encoding auto-detection in Python.  As smart as your browser.  Open source.</p>
-</div>
-<div class="s" id="quickSummary"><ul>
-<li class="li1">
-<a href="http://chardet.feedparser.org/download/">Download</a> ·</li>
-<li class="li2">
-<a href="index.html">Documentation</a> ·</li>
-<li class="li3"><a href="faq.html" title="Frequently Asked Questions">FAQ</a></li>
-</ul></div>
-</div></div></div>
-<div id="main"><div id="mainInner">
-<p id="breadcrumb">You are here: <a href="index.html">Documentation</a> → <span class="thispage">Frequently asked questions</span></p>
-<div class="section" lang="en">
-<div class="titlepage">
-<div><div><h2 class="title">
-<a name="faq" class="skip" href="#faq" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Frequently asked questions</h2></div></div>
-<div></div>
-</div>
-<div class="section" lang="en">
-<div class="titlepage">
-<div><div><h3 class="title">
-<a name="faq.intro" class="skip" href="#faq.intro" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> What is character encoding?</h3></div></div>
-<div></div>
-</div>
-<p>When you think of “<span class="quote">text</span>”, you probably think of “<span class="quote">characters and symbols I see on my computer screen</span>”.  But computers don't deal in characters and symbols; they deal in bits and bytes.  Every piece of text you've ever seen on a computer screen is actually stored in a particular <span class="emphasis"><em>character encoding</em></span>.  There are many different character encodings, some optimized for particular languages like Russian or Chinese or English, and others that can be used for multiple languages.  Very roughly speaking, the character encoding provides a mapping between the stuff you see on your screen and the stuff your computer actually stores in memory and on disk.</p>
-<p>In reality, it's more complicated than that.  Many characters are common to multiple encodings, but each encoding may use a different sequence of bytes to actually store those characters in memory or on disk.  So you can think of the character encoding as a kind of decryption key for the text.  Whenever someone gives you a sequence of bytes and claims it's “<span class="quote">text</span>”, you need to know what character encoding they used so you can decode the bytes into characters and display them (or process them, or whatever).</p>
-</div>
-<div class="section" lang="en">
-<div class="titlepage">
-<div><div><h3 class="title">
-<a name="faq.what" class="skip" href="#faq.what" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> What is character encoding auto-detection?</h3></div></div>
-<div></div>
-</div>
-<p>It means taking a sequence of bytes in an unknown character encoding, and attempting to determine the encoding so you can read the text.  It's like cracking a code when you don't have the decryption key.</p>
-</div>
-<div class="section" lang="en">
-<div class="titlepage">
-<div><div><h3 class="title">
-<a name="faq.impossible" class="skip" href="#faq.impossible" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Isn't that impossible?</h3></div></div>
-<div></div>
-</div>
-<p>In general, yes.  However, some encodings are optimized for specific languages, and languages are not random.  Some character sequences pop up all the time, while other sequences make no sense.  A person fluent in English who opens a newspaper and finds “<span class="quote">txzqJv 2!dasd0a QqdKjvz</span>” will instantly recognize that that isn't English (even though it is composed entirely of English letters).  By studying lots of “<span class="quote">typical</span>” text, a computer algorithm can simulate this kind of fluency and make an educated guess about a text's language.</p>
-<p>In other words, encoding detection is really language detection, combined with knowledge of which languages tend to use which character encodings.</p>
-</div>
-<div class="section" lang="en">
-<div class="titlepage">
-<div><div><h3 class="title">
-<a name="faq.who" class="skip" href="#faq.who" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Who wrote this detection algorithm?</h3></div></div>
-<div></div>
-</div>
-<p>This library is a port of <a href="http://lxr.mozilla.org/seamonkey/source/extensions/universalchardet/src/base/">the auto-detection code in Mozilla</a>.  I have attempted to maintain as much of the original structure as possible (mostly for selfish reasons, to make it easier to maintain the port as the original code evolves).  I have also retained the original authors' comments, which are quite extensive and informative.</p>
-<p>You may also be interested in the research paper which led to the Mozilla implementation, <a href="http://www.mozilla.org/projects/intl/UniversalCharsetDetection.html">A composite approach to language/encoding detection</a>.</p>
-</div>
-<div class="section" lang="en">
-<div class="titlepage">
-<div><div><h3 class="title">
-<a name="faq.yippie" class="skip" href="#faq.yippie" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Yippie!  Screw the standards, I'll just auto-detect everything!</h3></div></div>
-<div></div>
-</div>
-<p>Don't do that.  Virtually every format and protocol contains a method for specifying character encoding.</p>
-<div class="itemizedlist"><ul>
-<li>HTTP can define a <tt class="literal">charset</tt> parameter in the <tt class="literal">Content-type</tt> header.</li>
-<li>HTML documents can define a <tt class="literal">&lt;meta http-equiv="content-type"&gt;</tt> element in the <tt class="literal">&lt;head&gt;</tt> of a web page.</li>
-<li>XML documents can define an <tt class="literal">encoding</tt> attribute in the XML prolog.</li>
-</ul></div>
-<p>If text comes with explicit character encoding information, you should use it.  If the text has no explicit information, but the relevant standard defines a default encoding, you should use that.  (This is harder than it sounds, because standards can overlap.  If you fetch an XML document over HTTP, you need to support both standards <span class="emphasis"><em>and</em></span> figure out which one wins if they give you conflicting information.)</p>
-<p>Despite the complexity, it's worthwhile to follow standards and <a href="http://www.w3.org/2001/tag/doc/mime-respect">respect explicit character encoding information</a>.  It will almost certainly be faster and more accurate than trying to auto-detect the encoding.  It will also make the world a better place, since your program will interoperate with other programs that follow the same standards.</p>
-</div>
-<div class="section" lang="en">
-<div class="titlepage">
-<div><div><h3 class="title">
-<a name="faq.why" class="skip" href="#faq.why" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Why bother with auto-detection if it's slow, inaccurate, and non-standard?</h3></div></div>
-<div></div>
-</div>
-<p>Sometimes you receive text with verifiably inaccurate encoding information.  Or text without any encoding information, and the specified default encoding doesn't work.  There are also some poorly designed standards that have no way to specify encoding at all.</p>
-<p>If following the relevant standards gets you nowhere, <span class="emphasis"><em>and</em></span> you decide that processing the text is more important than maintaining interoperability, then you can try to auto-detect the character encoding as a last resort.  An example is my <a href="http://feedparser.org/">Universal Feed Parser</a>, which calls this auto-detection library <a href="http://feedparser.org/docs/character-encoding.html">only after exhausting all other options</a>.</p>
-</div>
-</div>
-<div class="footernavigation">
-<div style="float: left">← <a class="NavigationArrow" href="index.html">Documentation</a>
-</div>
-<div style="text-align: right">
-<a class="NavigationArrow" href="supported-encodings.html">Supported encodings</a> →</div>
-</div>
-<hr>
-<div id="footer"><p class="copyright">Copyright © 2006 Mark Pilgrim · <a href="mailto:mark@diveintomark.org">mark@diveintomark.org</a> · <a href="license.html">Terms of use</a></p></div>
-</div></div>
-</body>
-</html>
+<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
+<html lang="en">
+<head>
+<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
+<title>Frequently asked questions [Universal Encoding Detector]</title>
+<link rel="stylesheet" href="css/chardet.css" type="text/css">
+<link rev="made" href="mailto:mark@diveintomark.org">
+<meta name="generator" content="DocBook XSL Stylesheets V1.65.1">
+<meta name="keywords" content="character, set, encoding, detection, Python, XML, feed">
+<link rel="start" href="index.html" title="Documentation">
+<link rel="up" href="index.html" title="Documentation">
+<link rel="prev" href="index.html" title="Documentation">
+<link rel="next" href="supported-encodings.html" title="Supported encodings">
+</head>
+<body id="chardet-feedparser-org" class="docs">
+<div class="z" id="intro"><div class="sectionInner"><div class="sectionInner2">
+<div class="s" id="pageHeader">
+<h1><a href="/">Universal Encoding Detector</a></h1>
+<p>Character encoding auto-detection in Python.  As smart as your browser.  Open source.</p>
+</div>
+<div class="s" id="quickSummary"><ul>
+<li class="li1">
+<a href="http://chardet.feedparser.org/download/">Download</a> ·</li>
+<li class="li2">
+<a href="index.html">Documentation</a> ·</li>
+<li class="li3"><a href="faq.html" title="Frequently Asked Questions">FAQ</a></li>
+</ul></div>
+</div></div></div>
+<div id="main"><div id="mainInner">
+<p id="breadcrumb">You are here: <a href="index.html">Documentation</a> → <span class="thispage">Frequently asked questions</span></p>
+<div class="section" lang="en">
+<div class="titlepage">
+<div><div><h2 class="title">
+<a name="faq" class="skip" href="#faq" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Frequently asked questions</h2></div></div>
+<div></div>
+</div>
+<div class="section" lang="en">
+<div class="titlepage">
+<div><div><h3 class="title">
+<a name="faq.intro" class="skip" href="#faq.intro" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> What is character encoding?</h3></div></div>
+<div></div>
+</div>
+<p>When you think of “<span class="quote">text</span>”, you probably think of “<span class="quote">characters and symbols I see on my computer screen</span>”.  But computers don't deal in characters and symbols; they deal in bits and bytes.  Every piece of text you've ever seen on a computer screen is actually stored in a particular <span class="emphasis"><em>character encoding</em></span>.  There are many different character encodings, some optimized for particular languages like Russian or Chinese or English, and others that can be used for multiple languages.  Very roughly speaking, the character encoding provides a mapping between the stuff you see on your screen and the stuff your computer actually stores in memory and on disk.</p>
+<p>In reality, it's more complicated than that.  Many characters are common to multiple encodings, but each encoding may use a different sequence of bytes to actually store those characters in memory or on disk.  So you can think of the character encoding as a kind of decryption key for the text.  Whenever someone gives you a sequence of bytes and claims it's “<span class="quote">text</span>”, you need to know what character encoding they used so you can decode the bytes into characters and display them (or process them, or whatever).</p>
+</div>
+<div class="section" lang="en">
+<div class="titlepage">
+<div><div><h3 class="title">
+<a name="faq.what" class="skip" href="#faq.what" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> What is character encoding auto-detection?</h3></div></div>
+<div></div>
+</div>
+<p>It means taking a sequence of bytes in an unknown character encoding, and attempting to determine the encoding so you can read the text.  It's like cracking a code when you don't have the decryption key.</p>
+</div>
+<div class="section" lang="en">
+<div class="titlepage">
+<div><div><h3 class="title">
+<a name="faq.impossible" class="skip" href="#faq.impossible" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Isn't that impossible?</h3></div></div>
+<div></div>
+</div>
+<p>In general, yes.  However, some encodings are optimized for specific languages, and languages are not random.  Some character sequences pop up all the time, while other sequences make no sense.  A person fluent in English who opens a newspaper and finds “<span class="quote">txzqJv 2!dasd0a QqdKjvz</span>” will instantly recognize that that isn't English (even though it is composed entirely of English letters).  By studying lots of “<span class="quote">typical</span>” text, a computer algorithm can simulate this kind of fluency and make an educated guess about a text's language.</p>
+<p>In other words, encoding detection is really language detection, combined with knowledge of which languages tend to use which character encodings.</p>
+</div>
+<div class="section" lang="en">
+<div class="titlepage">
+<div><div><h3 class="title">
+<a name="faq.who" class="skip" href="#faq.who" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Who wrote this detection algorithm?</h3></div></div>
+<div></div>
+</div>
+<p>This library is a port of <a href="http://lxr.mozilla.org/seamonkey/source/extensions/universalchardet/src/base/">the auto-detection code in Mozilla</a>.  I have attempted to maintain as much of the original structure as possible (mostly for selfish reasons, to make it easier to maintain the port as the original code evolves).  I have also retained the original authors' comments, which are quite extensive and informative.</p>
+<p>You may also be interested in the research paper which led to the Mozilla implementation, <a href="http://www.mozilla.org/projects/intl/UniversalCharsetDetection.html">A composite approach to language/encoding detection</a>.</p>
+</div>
+<div class="section" lang="en">
+<div class="titlepage">
+<div><div><h3 class="title">
+<a name="faq.yippie" class="skip" href="#faq.yippie" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Yippie!  Screw the standards, I'll just auto-detect everything!</h3></div></div>
+<div></div>
+</div>
+<p>Don't do that.  Virtually every format and protocol contains a method for specifying character encoding.</p>
+<div class="itemizedlist"><ul>
+<li>HTTP can define a <tt class="literal">charset</tt> parameter in the <tt class="literal">Content-type</tt> header.</li>
+<li>HTML documents can define a <tt class="literal">&lt;meta http-equiv="content-type"&gt;</tt> element in the <tt class="literal">&lt;head&gt;</tt> of a web page.</li>
+<li>XML documents can define an <tt class="literal">encoding</tt> attribute in the XML prolog.</li>
+</ul></div>
+<p>If text comes with explicit character encoding information, you should use it.  If the text has no explicit information, but the relevant standard defines a default encoding, you should use that.  (This is harder than it sounds, because standards can overlap.  If you fetch an XML document over HTTP, you need to support both standards <span class="emphasis"><em>and</em></span> figure out which one wins if they give you conflicting information.)</p>
+<p>Despite the complexity, it's worthwhile to follow standards and <a href="http://www.w3.org/2001/tag/doc/mime-respect">respect explicit character encoding information</a>.  It will almost certainly be faster and more accurate than trying to auto-detect the encoding.  It will also make the world a better place, since your program will interoperate with other programs that follow the same standards.</p>
+</div>
+<div class="section" lang="en">
+<div class="titlepage">
+<div><div><h3 class="title">
+<a name="faq.why" class="skip" href="#faq.why" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Why bother with auto-detection if it's slow, inaccurate, and non-standard?</h3></div></div>
+<div></div>
+</div>
+<p>Sometimes you receive text with verifiably inaccurate encoding information.  Or text without any encoding information, and the specified default encoding doesn't work.  There are also some poorly designed standards that have no way to specify encoding at all.</p>
+<p>If following the relevant standards gets you nowhere, <span class="emphasis"><em>and</em></span> you decide that processing the text is more important than maintaining interoperability, then you can try to auto-detect the character encoding as a last resort.  An example is my <a href="http://feedparser.org/">Universal Feed Parser</a>, which calls this auto-detection library <a href="http://feedparser.org/docs/character-encoding.html">only after exhausting all other options</a>.</p>
+</div>
+</div>
+<div class="footernavigation">
+<div style="float: left">← <a class="NavigationArrow" href="index.html">Documentation</a>
+</div>
+<div style="text-align: right">
+<a class="NavigationArrow" href="supported-encodings.html">Supported encodings</a> →</div>
+</div>
+<hr>
+<div id="footer"><p class="copyright">Copyright © 2006, 2007, 2008 Mark Pilgrim · <a href="mailto:mark@diveintomark.org">mark@diveintomark.org</a> · <a href="license.html">Terms of use</a></p></div>
+</div></div>
+</body>
+</html>

=== added file 'docs/history.html'
--- docs/history.html	1970-01-01 00:00:00 +0000
+++ docs/history.html	2008-03-05 20:26:06 +0000
@@ -0,0 +1,65 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
+<html lang="en">
+<head>
+<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
+<title>Revision history [Universal Encoding Detector]</title>
+<link rel="stylesheet" href="css/chardet.css" type="text/css">
+<link rev="made" href="mailto:mark@diveintomark.org">
+<meta name="generator" content="DocBook XSL Stylesheets V1.65.1">
+<meta name="keywords" content="character, set, encoding, detection, Python, XML, feed">
+<link rel="start" href="index.html" title="Documentation">
+<link rel="up" href="index.html" title="Documentation">
+<link rel="prev" href="how-it-works.html" title="How it works">
+<link rel="next" href="license.html" title="Terms of use">
+</head>
+<body id="chardet-feedparser-org" class="docs">
+<div class="z" id="intro"><div class="sectionInner"><div class="sectionInner2">
+<div class="s" id="pageHeader">
+<h1><a href="/">Universal Encoding Detector</a></h1>
+<p>Character encoding auto-detection in Python.  As smart as your browser.  Open source.</p>
+</div>
+<div class="s" id="quickSummary"><ul>
+<li class="li1">
+<a href="http://chardet.feedparser.org/download/">Download</a> ·</li>
+<li class="li2">
+<a href="index.html">Documentation</a> ·</li>
+<li class="li3"><a href="faq.html" title="Frequently Asked Questions">FAQ</a></li>
+</ul></div>
+</div></div></div>
+<div id="main"><div id="mainInner">
+<p id="breadcrumb">You are here: <a href="index.html">Documentation</a> → <span class="thispage">Revision history</span></p>
+<div class="section" lang="en">
+<div class="titlepage">
+<div>
+<div><h2 class="title">
+<a name="history" class="skip" href="#history" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Revision history</h2></div>
+<div><div class="abstract">
+<h3 class="title"></h3>
+<p><span class="application">Universal Encoding Detector</span> is currently at version 1.0.1.</p>
+</div></div>
+</div>
+<div></div>
+</div>
+<div class="variablelist"><dl>
+<dt><span class="term"><tt class="constant">1.0.1</tt> (2008-03-05)</span></dt>
+<dd><div class="itemizedlist"><ul>
+<li>fixed typo in detecting little endian UTF-16; closes <a href="http://code.google.com/p/feedparser/issues/detail?id=81">issue 81</a>
+</li>
+<li>fixed length of <tt class="constant">ISO2022JPCharLenTable</tt>; closes <a href="http://code.google.com/p/feedparser/issues/detail?id=98">issue 98</a>
+</li>
+</ul></div></dd>
+<dt><span class="term"><tt class="constant">1.0</tt> (2006-01-10)</span></dt>
+<dd><div class="itemizedlist"><ul><li>Initial release</li></ul></div></dd>
+</dl></div>
+</div>
+<div class="footernavigation">
+<div style="float: left">← <a class="NavigationArrow" href="how-it-works.html">How it works</a>
+</div>
+<div style="text-align: right">
+<a class="NavigationArrow" href="license.html">Terms of use</a> →</div>
+</div>
+<hr>
+<div id="footer"><p class="copyright">Copyright © 2006, 2007, 2008 Mark Pilgrim · <a href="mailto:mark@diveintomark.org">mark@diveintomark.org</a> · <a href="license.html">Terms of use</a></p></div>
+</div></div>
+</body>
+</html>

=== modified file 'docs/how-it-works.html'
--- docs/how-it-works.html	2006-07-08 16:12:00 +0000
+++ docs/how-it-works.html	2008-03-05 20:26:06 +0000
@@ -1,113 +1,114 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
-<html lang="en">
-<head>
-<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<title>How it works [Universal Encoding Detector]</title>
-<link rel="stylesheet" href="css/chardet.css" type="text/css">
-<link rev="made" href="mailto:mark@diveintomark.org">
-<meta name="generator" content="DocBook XSL Stylesheets V1.65.1">
-<meta name="keywords" content="character, set, encoding, detection, Python, XML, feed">
-<link rel="start" href="index.html" title="Documentation">
-<link rel="up" href="index.html" title="Documentation">
-<link rel="prev" href="usage.html" title="Usage">
-<link rel="next" href="license.html" title="Terms of use">
-</head>
-<body id="chardet-feedparser-org" class="docs">
-<div class="z" id="intro"><div class="sectionInner"><div class="sectionInner2">
-<div class="s" id="pageHeader">
-<h1><a href="/">Universal Encoding Detector</a></h1>
-<p>Character encoding auto-detection in Python.  As smart as your browser.  Open source.</p>
-</div>
-<div class="s" id="quickSummary"><ul>
-<li class="li1">
-<a href="http://chardet.feedparser.org/download/">Download</a> ·</li>
-<li class="li2">
-<a href="index.html">Documentation</a> ·</li>
-<li class="li3"><a href="faq.html" title="Frequently Asked Questions">FAQ</a></li>
-</ul></div>
-</div></div></div>
-<div id="main"><div id="mainInner">
-<p id="breadcrumb">You are here: <a href="index.html">Documentation</a> → <span class="thispage">How it works</span></p>
-<div class="section" lang="en">
-<div class="titlepage">
-<div>
-<div><h2 class="title">
-<a name="howitworks" class="skip" href="#howitworks" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> How it works</h2></div>
-<div><div class="abstract">
-<h3 class="title"></h3>
-<p>This is a brief guide to navigating the code itself.</p>
-</div></div>
-</div>
-<div></div>
-</div>
-<p>First, you should read <a href="http://www.mozilla.org/projects/intl/UniversalCharsetDetection.html">A composite approach to language/encoding detection</a>, which explains the detection algorithm and how it was derived.  This will help you later when you stumble across the huge character frequency distribution tables like <tt class="filename">big5freq.py</tt> and language models like <tt class="filename">langcyrillicmodel.py</tt>.</p>
-<p>The main entry point for the detection algorithm is <tt class="filename">universaldetector.py</tt>, which has one class, <tt class="classname">UniversalDetector</tt>.  (You might think the main entry point is the <tt class="function">detect</tt> function in <tt class="filename">chardet/__init__.py</tt>, but that's really just a convenience function that creates a <tt class="classname">UniversalDetector</tt> object, calls it, and returns its result.)</p>
-<p>There are 5 categories of encodings that <tt class="classname">UniversalDetector</tt> handles:</p>
-<div class="orderedlist"><ol type="1">
-<li>
-<tt class="literal">UTF-n</tt> with a <acronym title="Byte Order Mark">BOM</acronym>.  This includes <tt class="literal">UTF-8</tt>, both <acronym title="Big Endian">BE</acronym> and <acronym title="Little Endian">LE</acronym> variants of <tt class="literal">UTF-16</tt>, and all 4 byte-order variants of <tt class="literal">UTF-32</tt>.</li>
-<li>Escaped encodings, which are entirely 7-bit <acronym>ASCII</acronym> compatible, where non-<acronym>ASCII</acronym> characters start with an escape sequence.  Examples: <tt class="literal">ISO-2022-JP</tt> (Japanese) and <tt class="literal">HZ-GB-2312</tt> (Chinese).</li>
-<li>Multi-byte encodings, where each character is represented by a variable number of bytes.  Examples: <tt class="literal">Big5</tt> (Chinese), <tt class="literal">SHIFT_JIS</tt> (Japanese), <tt class="literal">EUC-KR</tt> (Korean), and <tt class="literal">UTF-8</tt> without a <acronym title="Byte Order Mark">BOM</acronym>.</li>
-<li>Single-byte encodings, where each character is represented by one byte.  Examples: <tt class="literal">KOI8-R</tt> (Russian), <tt class="literal">windows-1255</tt> (Hebrew), and <tt class="literal">TIS-620</tt> (Thai).</li>
-<li>
-<tt class="literal">windows-1252</tt>, which is used primarily on Microsoft Windows by middle managers who don't know a character encoding from a hole in the ground.</li>
-</ol></div>
-<div class="section" lang="en">
-<div class="titlepage">
-<div><div><h3 class="title">
-<a name="how.bom" class="skip" href="#how.bom" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> <tt class="literal">UTF-n</tt> with a <acronym title="Byte Order Mark">BOM</acronym></h3></div></div>
-<div></div>
-</div>
-<p>If the text starts with a <acronym title="Byte Order Mark">BOM</acronym>, we can reasonably assume that the text is encoded in <tt class="literal">UTF-8</tt>, <tt class="literal">UTF-16</tt>, or <tt class="literal">UTF-32</tt>.  (The <acronym title="Byte Order Mark">BOM</acronym> will tell us exactly which one; that's what it's for.)  This is handled inline in <tt class="classname">UniversalDetector</tt>, which returns the result immediately without any further processing.</p>
-</div>
-<div class="section" lang="en">
-<div class="titlepage">
-<div><div><h3 class="title">
-<a name="how.esc" class="skip" href="#how.esc" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Escaped encodings</h3></div></div>
-<div></div>
-</div>
-<p>If the text contains a recognizable escape sequence that might indicate an escaped encoding, <tt class="classname">UniversalDetector</tt> creates an <tt class="classname">EscCharSetProber</tt> (defined in <tt class="filename">escprober.py</tt>) and feeds it the text.</p>
-<p><tt class="classname">EscCharSetProber</tt> creates a series of state machines, based on models of <tt class="literal">HZ-GB-2312</tt>, <tt class="literal">ISO-2022-CN</tt>, <tt class="literal">ISO-2022-JP</tt>, and <tt class="literal">ISO-2022-KR</tt> (defined in <tt class="filename">escsm.py</tt>).  <tt class="classname">EscCharSetProber</tt> feeds the text to each of these state machines, one byte at a time.  If any state machine ends up uniquely identifying the encoding, <tt class="classname">EscCharSetProber</tt> immediately returns the positive result to <tt class="classname">UniversalDetector</tt>, which returns it to the caller.  If any state machine hits an illegal sequence, it is dropped and processing continues with the other state machines.</p>
-</div>
-<div class="section" lang="en">
-<div class="titlepage">
-<div><div><h3 class="title">
-<a name="how.mb" class="skip" href="#how.mb" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Multi-byte encodings</h3></div></div>
-<div></div>
-</div>
-<p>Assuming no <acronym title="Byte Order Mark">BOM</acronym>, <tt class="classname">UniversalDetector</tt> checks whether the text contains any high-bit characters.  If so, it creates a series of “<span class="quote">probers</span>” for detecting multi-byte encodings, single-byte encodings, and as a last resort, <tt class="literal">windows-1252</tt>.</p>
-<p>The multi-byte encoding prober, <tt class="classname">MBCSGroupProber</tt> (defined in <tt class="filename">mbcsgroupprober.py</tt>), is really just a shell that manages a group of other probers, one for each multi-byte encoding: <tt class="literal">Big5</tt>, <tt class="literal">GB2312</tt>, <tt class="literal">EUC-TW</tt>, <tt class="literal">EUC-KR</tt>, <tt class="literal">EUC-JP</tt>, <tt class="literal">SHIFT_JIS</tt>, and <tt class="literal">UTF-8</tt>.  <tt class="classname">MBCSGroupProber</tt> feeds the text to each of these encoding-specific probers and checks the results.  If a prober reports that it has found an illegal byte sequence, it is dropped from further processing (so that, for instance, any subsequent calls to <tt class="classname">UniversalDetector</tt>.<tt class="methodname">feed</tt> will skip that prober).  If a prober reports that it is reasonably confident that it has detected the encoding, <tt class="classname">MBCSGroupProber</tt> reports this positive result to <tt class="classname">UniversalDetector</tt>, which reports the result to the caller.</p>
-<p>Most of the multi-byte encoding probers are inherited from <tt class="classname">MultiByteCharSetProber</tt> (defined in <tt class="filename">mbcharsetprober.py</tt>), and simply hook up the appropriate state machine and distribution analyzer and let <tt class="classname">MultiByteCharSetProber</tt> do the rest of the work.  <tt class="classname">MultiByteCharSetProber</tt> runs the text through the encoding-specific state machine, one byte at a time, to look for byte sequences that would indicate a conclusive positive or negative result.  At the same time, <tt class="classname">MultiByteCharSetProber</tt> feeds the text to an encoding-specific distribution analyzer.</p>
-<p>The distribution analyzers (each defined in <tt class="filename">chardistribution.py</tt>) use language-specific models of which characters are used most frequently.  Once <tt class="classname">MultiByteCharSetProber</tt> has fed enough text to the distribution analyzer, it calculates a confidence rating based on the number of frequently-used characters, the total number of character,s and a language-specific distribution ratio.  If the confidence is high enough, <tt class="classname">MultiByteCharSetProber</tt> returns the result to <tt class="classname">MBCSGroupProber</tt>, which returns it to <tt class="classname">UniversalDetector</tt>, which returns it to the caller.</p>
-<p>The case of Japanese is more difficult.  Single-character distribution analysis is not always sufficient to distinguish between <tt class="literal">EUC-JP</tt> and <tt class="literal">SHIFT_JIS</tt>, so the <tt class="classname">SJISProber</tt> (defined in <tt class="filename">sjisprober.py</tt>) also uses 2-character distribution analysis.  <tt class="classname">SJISContextAnalysis</tt> and <tt class="classname">EUCJPContextAnalysis</tt> (both defined in <tt class="filename">jpcntx.py</tt> and both inheriting from a common <tt class="classname">JapaneseContextAnalysis</tt> class) check the frequency of Hiragana syllabary characters within the text.  Once enough text has been processed, they return a confidence level to <tt class="classname">SJISProber</tt>, which checks both analyzers and returns the higher confidence level to <tt class="classname">MBCSGroupProber</tt>.</p>
-</div>
-<div class="section" lang="en">
-<div class="titlepage">
-<div><div><h3 class="title">
-<a name="how.sb" class="skip" href="#how.sb" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Single-byte encodings</h3></div></div>
-<div></div>
-</div>
-<p>The single-byte encoding prober, <tt class="classname">SBCSGroupProber</tt> (defined in <tt class="filename">sbcsgroupprober.py</tt>), is also just a shell that manages a group of other probers, one for each combination of single-byte encoding and language: <tt class="literal">windows-1251</tt>, <tt class="literal">KOI8-R</tt>, <tt class="literal">ISO-8859-5</tt>, <tt class="literal">MacCyrillic</tt>, <tt class="literal">IBM855</tt>, and <tt class="literal">IBM866</tt> (Russian); <tt class="literal">ISO-8859-7</tt> and <tt class="literal">windows-1253</tt> (Greek); <tt class="literal">ISO-8859-5</tt> and <tt class="literal">windows-1251</tt> (Bulgarian); <tt class="literal">ISO-8859-2</tt> and <tt class="literal">windows-1250</tt> (Hungarian); <tt class="literal">TIS-620</tt> (Thai); <tt class="literal">windows-1255</tt> and <tt class="literal">ISO-8859-8</tt> (Hebrew).</p>
-<p><tt class="classname">SBCSGroupProber</tt> feeds the text to each of these encoding+language-specific probers and checks the results.  These probers are all implemented as a single class, <tt class="classname">SingleByteCharSetProber</tt> (defined in <tt class="filename">sbcharsetprober.py</tt>), which takes a language model as an argument.  The language model defines how frequently different 2-character sequences appear in typical text.  <tt class="classname">SingleByteCharSetProber</tt> processes the text and tallies the most frequently used 2-character sequences.  Once enough text has been processed, it calculates a confidence level based on the number of frequently-used sequences, the total number of characters, and a language-specific distribution ratio.</p>
-<p>Hebrew is handled as a special case.  If the text appears to be Hebrew based on 2-character distribution analysis, <tt class="classname">HebrewProber</tt> (defined in <tt class="filename">hebrewprober.py</tt>) tries to distinguish between Visual Hebrew (where the source text actually stored “<span class="quote">backwards</span>” line-by-line, and then displayed verbatim so it can be read from right to left) and Logical Hebrew (where the source text is stored in reading order and then rendered right-to-left by the client).  Because certain characters are encoded differently based on whether they appear in the middle of or at the end of a word, we can make a reasonable guess about direction of the source text, and return the appropriate encoding (<tt class="literal">windows-1255</tt> for Logical Hebrew, or <tt class="literal">ISO-8859-8</tt> for Visual Hebrew).</p>
-</div>
-<div class="section" lang="en">
-<div class="titlepage">
-<div><div><h3 class="title">
-<a name="how.windows1252" class="skip" href="#how.windows1252" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> windows-1252</h3></div></div>
-<div></div>
-</div>
-<p>If <tt class="classname">UniversalDetector</tt> detects a high-bit character in the text, but none of the other multi-byte or single-byte encoding probers return a confident result, it creates a <tt class="classname">Latin1Prober</tt> (defined in <tt class="filename">latin1prober.py</tt>) to try to detect English text in a <tt class="literal">windows-1252</tt> encoding.  This detection is inherently unreliable, because English letters are encoded in the same way in many different encodings.  The only way to distinguish <tt class="literal">windows-1252</tt> is through commonly used symbols like smart quotes, curly apostrophes, copyright symbols, and the like.  <tt class="classname">Latin1Prober</tt> automatically reduces its confidence rating to allow more accurate probers to win if at all possible.</p>
-</div>
-</div>
-<div class="footernavigation">
-<div style="float: left">← <a class="NavigationArrow" href="usage.html">Usage</a>
-</div>
-<div style="text-align: right">
-<a class="NavigationArrow" href="license.html">Terms of use</a> →</div>
-</div>
-<hr>
-<div id="footer"><p class="copyright">Copyright © 2006 Mark Pilgrim · <a href="mailto:mark@diveintomark.org">mark@diveintomark.org</a> · <a href="license.html">Terms of use</a></p></div>
-</div></div>
-</body>
-</html>
+<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
+<html lang="en">
+<head>
+<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
+<title>How it works [Universal Encoding Detector]</title>
+<link rel="stylesheet" href="css/chardet.css" type="text/css">
+<link rev="made" href="mailto:mark@diveintomark.org">
+<meta name="generator" content="DocBook XSL Stylesheets V1.65.1">
+<meta name="keywords" content="character, set, encoding, detection, Python, XML, feed">
+<link rel="start" href="index.html" title="Documentation">
+<link rel="up" href="index.html" title="Documentation">
+<link rel="prev" href="usage.html" title="Usage">
+<link rel="next" href="history.html" title="Revision history">
+</head>
+<body id="chardet-feedparser-org" class="docs">
+<div class="z" id="intro"><div class="sectionInner"><div class="sectionInner2">
+<div class="s" id="pageHeader">
+<h1><a href="/">Universal Encoding Detector</a></h1>
+<p>Character encoding auto-detection in Python.  As smart as your browser.  Open source.</p>
+</div>
+<div class="s" id="quickSummary"><ul>
+<li class="li1">
+<a href="http://chardet.feedparser.org/download/">Download</a> ·</li>
+<li class="li2">
+<a href="index.html">Documentation</a> ·</li>
+<li class="li3"><a href="faq.html" title="Frequently Asked Questions">FAQ</a></li>
+</ul></div>
+</div></div></div>
+<div id="main"><div id="mainInner">
+<p id="breadcrumb">You are here: <a href="index.html">Documentation</a> → <span class="thispage">How it works</span></p>
+<div class="section" lang="en">
+<div class="titlepage">
+<div>
+<div><h2 class="title">
+<a name="howitworks" class="skip" href="#howitworks" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> How it works</h2></div>
+<div><div class="abstract">
+<h3 class="title"></h3>
+<p>This is a brief guide to navigating the code itself.</p>
+</div></div>
+</div>
+<div></div>
+</div>
+<p>First, you should read <a href="http://www.mozilla.org/projects/intl/UniversalCharsetDetection.html">A composite approach to language/encoding detection</a>, which explains the detection algorithm and how it was derived.  This will help you later when you stumble across the huge character frequency distribution tables like <tt class="filename">big5freq.py</tt> and language models like <tt class="filename">langcyrillicmodel.py</tt>.</p>
+<p>The main entry point for the detection algorithm is <tt class="filename">universaldetector.py</tt>, which has one class, <tt class="classname">UniversalDetector</tt>.  (You might think the main entry point is the <tt class="function">detect</tt> function in <tt class="filename">chardet/__init__.py</tt>, but that's really just a convenience function that creates a <tt class="classname">UniversalDetector</tt> object, calls it, and returns its result.)</p>
+<p>There are 5 categories of encodings that <tt class="classname">UniversalDetector</tt> handles:</p>
+<div class="orderedlist"><ol type="1">
+<li>
+<tt class="literal">UTF-n</tt> with a <acronym title="Byte Order Mark">BOM</acronym>.  This includes <tt class="literal">UTF-8</tt>, both <acronym title="Big Endian">BE</acronym> and <acronym title="Little Endian">LE</acronym> variants of <tt class="literal">UTF-16</tt>, and all 4 byte-order variants of <tt class="literal">UTF-32</tt>.</li>
+<li>Escaped encodings, which are entirely 7-bit <acronym>ASCII</acronym> compatible, where non-<acronym>ASCII</acronym> characters start with an escape sequence.  Examples: <tt class="literal">ISO-2022-JP</tt> (Japanese) and <tt class="literal">HZ-GB-2312</tt> (Chinese).</li>
+<li>Multi-byte encodings, where each character is represented by a variable number of bytes.  Examples: <tt class="literal">Big5</tt> (Chinese), <tt class="literal">SHIFT_JIS</tt> (Japanese), <tt class="literal">EUC-KR</tt> (Korean), and <tt class="literal">UTF-8</tt> without a <acronym title="Byte Order Mark">BOM</acronym>.</li>
+<li>Single-byte encodings, where each character is represented by one byte.  Examples: <tt class="literal">KOI8-R</tt> (Russian), <tt class="literal">windows-1255</tt> (Hebrew), and <tt class="literal">TIS-620</tt> (Thai).</li>
+<li>
+<tt class="literal">windows-1252</tt>, which is used primarily on Microsoft Windows by middle managers who don't know a character encoding from a hole in the ground.</li>
+</ol></div>
+<div class="section" lang="en">
+<div class="titlepage">
+<div><div><h3 class="title">
+<a name="how.bom" class="skip" href="#how.bom" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> <tt class="literal">UTF-n</tt> with a <acronym title="Byte Order Mark">BOM</acronym>
+</h3></div></div>
+<div></div>
+</div>
+<p>If the text starts with a <acronym title="Byte Order Mark">BOM</acronym>, we can reasonably assume that the text is encoded in <tt class="literal">UTF-8</tt>, <tt class="literal">UTF-16</tt>, or <tt class="literal">UTF-32</tt>.  (The <acronym title="Byte Order Mark">BOM</acronym> will tell us exactly which one; that's what it's for.)  This is handled inline in <tt class="classname">UniversalDetector</tt>, which returns the result immediately without any further processing.</p>
+</div>
+<div class="section" lang="en">
+<div class="titlepage">
+<div><div><h3 class="title">
+<a name="how.esc" class="skip" href="#how.esc" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Escaped encodings</h3></div></div>
+<div></div>
+</div>
+<p>If the text contains a recognizable escape sequence that might indicate an escaped encoding, <tt class="classname">UniversalDetector</tt> creates an <tt class="classname">EscCharSetProber</tt> (defined in <tt class="filename">escprober.py</tt>) and feeds it the text.</p>
+<p><tt class="classname">EscCharSetProber</tt> creates a series of state machines, based on models of <tt class="literal">HZ-GB-2312</tt>, <tt class="literal">ISO-2022-CN</tt>, <tt class="literal">ISO-2022-JP</tt>, and <tt class="literal">ISO-2022-KR</tt> (defined in <tt class="filename">escsm.py</tt>).  <tt class="classname">EscCharSetProber</tt> feeds the text to each of these state machines, one byte at a time.  If any state machine ends up uniquely identifying the encoding, <tt class="classname">EscCharSetProber</tt> immediately returns the positive result to <tt class="classname">UniversalDetector</tt>, which returns it to the caller.  If any state machine hits an illegal sequence, it is dropped and processing continues with the other state machines.</p>
+</div>
+<div class="section" lang="en">
+<div class="titlepage">
+<div><div><h3 class="title">
+<a name="how.mb" class="skip" href="#how.mb" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Multi-byte encodings</h3></div></div>
+<div></div>
+</div>
+<p>Assuming no <acronym title="Byte Order Mark">BOM</acronym>, <tt class="classname">UniversalDetector</tt> checks whether the text contains any high-bit characters.  If so, it creates a series of “<span class="quote">probers</span>” for detecting multi-byte encodings, single-byte encodings, and as a last resort, <tt class="literal">windows-1252</tt>.</p>
+<p>The multi-byte encoding prober, <tt class="classname">MBCSGroupProber</tt> (defined in <tt class="filename">mbcsgroupprober.py</tt>), is really just a shell that manages a group of other probers, one for each multi-byte encoding: <tt class="literal">Big5</tt>, <tt class="literal">GB2312</tt>, <tt class="literal">EUC-TW</tt>, <tt class="literal">EUC-KR</tt>, <tt class="literal">EUC-JP</tt>, <tt class="literal">SHIFT_JIS</tt>, and <tt class="literal">UTF-8</tt>.  <tt class="classname">MBCSGroupProber</tt> feeds the text to each of these encoding-specific probers and checks the results.  If a prober reports that it has found an illegal byte sequence, it is dropped from further processing (so that, for instance, any subsequent calls to <tt class="classname">UniversalDetector</tt>.<tt class="methodname">feed</tt> will skip that prober).  If a prober reports that it is reasonably confident that it has detected the encoding, <tt class="classname">MBCSGroupProber</tt> reports this positive result to <tt class="classname">UniversalDetector</tt>, which reports the result to the caller.</p>
+<p>Most of the multi-byte encoding probers are inherited from <tt class="classname">MultiByteCharSetProber</tt> (defined in <tt class="filename">mbcharsetprober.py</tt>), and simply hook up the appropriate state machine and distribution analyzer and let <tt class="classname">MultiByteCharSetProber</tt> do the rest of the work.  <tt class="classname">MultiByteCharSetProber</tt> runs the text through the encoding-specific state machine, one byte at a time, to look for byte sequences that would indicate a conclusive positive or negative result.  At the same time, <tt class="classname">MultiByteCharSetProber</tt> feeds the text to an encoding-specific distribution analyzer.</p>
+<p>The distribution analyzers (each defined in <tt class="filename">chardistribution.py</tt>) use language-specific models of which characters are used most frequently.  Once <tt class="classname">MultiByteCharSetProber</tt> has fed enough text to the distribution analyzer, it calculates a confidence rating based on the number of frequently-used characters, the total number of characters, and a language-specific distribution ratio.  If the confidence is high enough, <tt class="classname">MultiByteCharSetProber</tt> returns the result to <tt class="classname">MBCSGroupProber</tt>, which returns it to <tt class="classname">UniversalDetector</tt>, which returns it to the caller.</p>
+<p>The case of Japanese is more difficult.  Single-character distribution analysis is not always sufficient to distinguish between <tt class="literal">EUC-JP</tt> and <tt class="literal">SHIFT_JIS</tt>, so the <tt class="classname">SJISProber</tt> (defined in <tt class="filename">sjisprober.py</tt>) also uses 2-character distribution analysis.  <tt class="classname">SJISContextAnalysis</tt> and <tt class="classname">EUCJPContextAnalysis</tt> (both defined in <tt class="filename">jpcntx.py</tt> and both inheriting from a common <tt class="classname">JapaneseContextAnalysis</tt> class) check the frequency of Hiragana syllabary characters within the text.  Once enough text has been processed, they return a confidence level to <tt class="classname">SJISProber</tt>, which checks both analyzers and returns the higher confidence level to <tt class="classname">MBCSGroupProber</tt>.</p>
+</div>
+<div class="section" lang="en">
+<div class="titlepage">
+<div><div><h3 class="title">
+<a name="how.sb" class="skip" href="#how.sb" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Single-byte encodings</h3></div></div>
+<div></div>
+</div>
+<p>The single-byte encoding prober, <tt class="classname">SBCSGroupProber</tt> (defined in <tt class="filename">sbcsgroupprober.py</tt>), is also just a shell that manages a group of other probers, one for each combination of single-byte encoding and language: <tt class="literal">windows-1251</tt>, <tt class="literal">KOI8-R</tt>, <tt class="literal">ISO-8859-5</tt>, <tt class="literal">MacCyrillic</tt>, <tt class="literal">IBM855</tt>, and <tt class="literal">IBM866</tt> (Russian); <tt class="literal">ISO-8859-7</tt> and <tt class="literal">windows-1253</tt> (Greek); <tt class="literal">ISO-8859-5</tt> and <tt class="literal">windows-1251</tt> (Bulgarian); <tt class="literal">ISO-8859-2</tt> and <tt class="literal">windows-1250</tt> (Hungarian); <tt class="literal">TIS-620</tt> (Thai); <tt class="literal">windows-1255</tt> and <tt class="literal">ISO-8859-8</tt> (Hebrew).</p>
+<p><tt class="classname">SBCSGroupProber</tt> feeds the text to each of these encoding+language-specific probers and checks the results.  These probers are all implemented as a single class, <tt class="classname">SingleByteCharSetProber</tt> (defined in <tt class="filename">sbcharsetprober.py</tt>), which takes a language model as an argument.  The language model defines how frequently different 2-character sequences appear in typical text.  <tt class="classname">SingleByteCharSetProber</tt> processes the text and tallies the most frequently used 2-character sequences.  Once enough text has been processed, it calculates a confidence level based on the number of frequently-used sequences, the total number of characters, and a language-specific distribution ratio.</p>
+<p>Hebrew is handled as a special case.  If the text appears to be Hebrew based on 2-character distribution analysis, <tt class="classname">HebrewProber</tt> (defined in <tt class="filename">hebrewprober.py</tt>) tries to distinguish between Visual Hebrew (where the source text actually stored “<span class="quote">backwards</span>” line-by-line, and then displayed verbatim so it can be read from right to left) and Logical Hebrew (where the source text is stored in reading order and then rendered right-to-left by the client).  Because certain characters are encoded differently based on whether they appear in the middle of or at the end of a word, we can make a reasonable guess about direction of the source text, and return the appropriate encoding (<tt class="literal">windows-1255</tt> for Logical Hebrew, or <tt class="literal">ISO-8859-8</tt> for Visual Hebrew).</p>
+</div>
+<div class="section" lang="en">
+<div class="titlepage">
+<div><div><h3 class="title">
+<a name="how.windows1252" class="skip" href="#how.windows1252" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> windows-1252</h3></div></div>
+<div></div>
+</div>
+<p>If <tt class="classname">UniversalDetector</tt> detects a high-bit character in the text, but none of the other multi-byte or single-byte encoding probers return a confident result, it creates a <tt class="classname">Latin1Prober</tt> (defined in <tt class="filename">latin1prober.py</tt>) to try to detect English text in a <tt class="literal">windows-1252</tt> encoding.  This detection is inherently unreliable, because English letters are encoded in the same way in many different encodings.  The only way to distinguish <tt class="literal">windows-1252</tt> is through commonly used symbols like smart quotes, curly apostrophes, copyright symbols, and the like.  <tt class="classname">Latin1Prober</tt> automatically reduces its confidence rating to allow more accurate probers to win if at all possible.</p>
+</div>
+</div>
+<div class="footernavigation">
+<div style="float: left">← <a class="NavigationArrow" href="usage.html">Usage</a>
+</div>
+<div style="text-align: right">
+<a class="NavigationArrow" href="history.html">Revision history</a> →</div>
+</div>
+<hr>
+<div id="footer"><p class="copyright">Copyright © 2006, 2007, 2008 Mark Pilgrim · <a href="mailto:mark@diveintomark.org">mark@diveintomark.org</a> · <a href="license.html">Terms of use</a></p></div>
+</div></div>
+</body>
+</html>

=== modified file 'docs/index.html'
--- docs/index.html	2006-07-08 16:12:00 +0000
+++ docs/index.html	2008-03-05 20:26:06 +0000
@@ -1,73 +1,74 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
-<html lang="en">
-<head>
-<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<title>Documentation [Universal Encoding Detector]</title>
-<link rel="stylesheet" href="css/chardet.css" type="text/css">
-<link rev="made" href="mailto:mark@diveintomark.org">
-<meta name="generator" content="DocBook XSL Stylesheets V1.65.1">
-<meta name="keywords" content="character, set, encoding, detection, Python, XML, feed">
-<link rel="start" href="index.html" title="Documentation">
-<link rel="next" href="faq.html" title="Frequently asked questions">
-</head>
-<body id="chardet-feedparser-org" class="docs">
-<div class="z" id="intro"><div class="sectionInner"><div class="sectionInner2">
-<div class="s" id="pageHeader">
-<h1><a href="/">Universal Encoding Detector</a></h1>
-<p>Character encoding auto-detection in Python.  As smart as your browser.  Open source.</p>
-</div>
-<div class="s" id="quickSummary"><ul>
-<li class="li1">
-<a href="http://chardet.feedparser.org/download/">Download</a> ·</li>
-<li class="li2">
-<a href="index.html">Documentation</a> ·</li>
-<li class="li3"><a href="faq.html" title="Frequently Asked Questions">FAQ</a></li>
-</ul></div>
-</div></div></div>
-<div id="main"><div id="mainInner">
-<p id="breadcrumb">You are here: <span class="thispage">Documentation</span></p>
-<div class="article" lang="en">
-<div class="titlepage">
-<div></div>
-<div></div>
-</div>
-<div class="toc"><ul>
-<li>
-<span class="section"><a href="faq.html">Frequently asked questions</a></span><ul>
-<li><span class="section"><a href="faq.html#faq.intro">What is character encoding?</a></span></li>
-<li><span class="section"><a href="faq.html#faq.what">What is character encoding auto-detection?</a></span></li>
-<li><span class="section"><a href="faq.html#faq.impossible">Isn't that impossible?</a></span></li>
-<li><span class="section"><a href="faq.html#faq.who">Who wrote this detection algorithm?</a></span></li>
-<li><span class="section"><a href="faq.html#faq.yippie">Yippie!  Screw the standards, I'll just auto-detect everything!</a></span></li>
-<li><span class="section"><a href="faq.html#faq.why">Why bother with auto-detection if it's slow, inaccurate, and non-standard?</a></span></li>
-</ul>
-</li>
-<li><span class="section"><a href="supported-encodings.html">Supported encodings</a></span></li>
-<li>
-<span class="section"><a href="usage.html">Usage</a></span><ul>
-<li><span class="section"><a href="usage.html#usage.basic">Basic usage</a></span></li>
-<li><span class="section"><a href="usage.html#usage.advanced">Advanced usage</a></span></li>
-</ul>
-</li>
-<li>
-<span class="section"><a href="how-it-works.html">How it works</a></span><ul>
-<li><span class="section"><a href="how-it-works.html#how.bom">UTF-n with a BOM</a></span></li>
-<li><span class="section"><a href="how-it-works.html#how.esc">Escaped encodings</a></span></li>
-<li><span class="section"><a href="how-it-works.html#how.mb">Multi-byte encodings</a></span></li>
-<li><span class="section"><a href="how-it-works.html#how.sb">Single-byte encodings</a></span></li>
-<li><span class="section"><a href="how-it-works.html#how.windows1252">windows-1252</a></span></li>
-</ul>
-</li>
-<li><span class="appendix"><a href="license.html">Terms of use</a></span></li>
-</ul></div>
-</div>
-<div class="footernavigation">
-<div style="float: left"></div>
-<div style="text-align: right">
-<a class="NavigationArrow" href="faq.html">Frequently asked questions</a> →</div>
-</div>
-<hr>
-<div id="footer"><p class="copyright">Copyright © 2006 Mark Pilgrim · <a href="mailto:mark@diveintomark.org">mark@diveintomark.org</a> · <a href="license.html">Terms of use</a></p></div>
-</div></div>
-</body>
-</html>
+<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
+<html lang="en">
+<head>
+<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
+<title>Documentation [Universal Encoding Detector]</title>
+<link rel="stylesheet" href="css/chardet.css" type="text/css">
+<link rev="made" href="mailto:mark@diveintomark.org">
+<meta name="generator" content="DocBook XSL Stylesheets V1.65.1">
+<meta name="keywords" content="character, set, encoding, detection, Python, XML, feed">
+<link rel="start" href="index.html" title="Documentation">
+<link rel="next" href="faq.html" title="Frequently asked questions">
+</head>
+<body id="chardet-feedparser-org" class="docs">
+<div class="z" id="intro"><div class="sectionInner"><div class="sectionInner2">
+<div class="s" id="pageHeader">
+<h1><a href="/">Universal Encoding Detector</a></h1>
+<p>Character encoding auto-detection in Python.  As smart as your browser.  Open source.</p>
+</div>
+<div class="s" id="quickSummary"><ul>
+<li class="li1">
+<a href="http://chardet.feedparser.org/download/">Download</a> ·</li>
+<li class="li2">
+<a href="index.html">Documentation</a> ·</li>
+<li class="li3"><a href="faq.html" title="Frequently Asked Questions">FAQ</a></li>
+</ul></div>
+</div></div></div>
+<div id="main"><div id="mainInner">
+<p id="breadcrumb">You are here: <span class="thispage">Documentation</span></p>
+<div class="article" lang="en">
+<div class="titlepage">
+<div></div>
+<div></div>
+</div>
+<div class="toc"><ul>
+<li>
+<span class="section"><a href="faq.html">Frequently asked questions</a></span><ul>
+<li><span class="section"><a href="faq.html#faq.intro">What is character encoding?</a></span></li>
+<li><span class="section"><a href="faq.html#faq.what">What is character encoding auto-detection?</a></span></li>
+<li><span class="section"><a href="faq.html#faq.impossible">Isn't that impossible?</a></span></li>
+<li><span class="section"><a href="faq.html#faq.who">Who wrote this detection algorithm?</a></span></li>
+<li><span class="section"><a href="faq.html#faq.yippie">Yippie!  Screw the standards, I'll just auto-detect everything!</a></span></li>
+<li><span class="section"><a href="faq.html#faq.why">Why bother with auto-detection if it's slow, inaccurate, and non-standard?</a></span></li>
+</ul>
+</li>
+<li><span class="section"><a href="supported-encodings.html">Supported encodings</a></span></li>
+<li>
+<span class="section"><a href="usage.html">Usage</a></span><ul>
+<li><span class="section"><a href="usage.html#usage.basic">Basic usage</a></span></li>
+<li><span class="section"><a href="usage.html#usage.advanced">Advanced usage</a></span></li>
+</ul>
+</li>
+<li>
+<span class="section"><a href="how-it-works.html">How it works</a></span><ul>
+<li><span class="section"><a href="how-it-works.html#how.bom">UTF-n with a BOM</a></span></li>
+<li><span class="section"><a href="how-it-works.html#how.esc">Escaped encodings</a></span></li>
+<li><span class="section"><a href="how-it-works.html#how.mb">Multi-byte encodings</a></span></li>
+<li><span class="section"><a href="how-it-works.html#how.sb">Single-byte encodings</a></span></li>
+<li><span class="section"><a href="how-it-works.html#how.windows1252">windows-1252</a></span></li>
+</ul>
+</li>
+<li><span class="section"><a href="history.html">Revision history</a></span></li>
+<li><span class="appendix"><a href="license.html">Terms of use</a></span></li>
+</ul></div>
+</div>
+<div class="footernavigation">
+<div style="float: left"></div>
+<div style="text-align: right">
+<a class="NavigationArrow" href="faq.html">Frequently asked questions</a> →</div>
+</div>
+<hr>
+<div id="footer"><p class="copyright">Copyright © 2006, 2007, 2008 Mark Pilgrim · <a href="mailto:mark@diveintomark.org">mark@diveintomark.org</a> · <a href="license.html">Terms of use</a></p></div>
+</div></div>
+</body>
+</html>

=== modified file 'docs/license.html'
--- docs/license.html	2006-07-08 16:12:00 +0000
+++ docs/license.html	2008-03-05 20:26:06 +0000
@@ -1,62 +1,62 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
-<html lang="en">
-<head>
-<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<title>Terms of use [Universal Encoding Detector]</title>
-<link rel="stylesheet" href="css/chardet.css" type="text/css">
-<link rev="made" href="mailto:mark@diveintomark.org">
-<meta name="generator" content="DocBook XSL Stylesheets V1.65.1">
-<meta name="keywords" content="character, set, encoding, detection, Python, XML, feed">
-<link rel="start" href="index.html" title="Documentation">
-<link rel="up" href="index.html" title="Documentation">
-<link rel="prev" href="how-it-works.html" title="How it works">
-</head>
-<body id="chardet-feedparser-org" class="docs">
-<div class="z" id="intro"><div class="sectionInner"><div class="sectionInner2">
-<div class="s" id="pageHeader">
-<h1><a href="/">Universal Encoding Detector</a></h1>
-<p>Character encoding auto-detection in Python.  As smart as your browser.  Open source.</p>
-</div>
-<div class="s" id="quickSummary"><ul>
-<li class="li1">
-<a href="http://chardet.feedparser.org/download/">Download</a> ·</li>
-<li class="li2">
-<a href="index.html">Documentation</a> ·</li>
-<li class="li3"><a href="faq.html" title="Frequently Asked Questions">FAQ</a></li>
-</ul></div>
-</div></div></div>
-<div id="main"><div id="mainInner">
-<p id="breadcrumb">You are here: <a href="index.html">Documentation</a> → <span class="thispage">Terms of use</span></p>
-<div class="appendix" lang="en">
-<div class="titlepage">
-<div><div><h2 class="title">
-<a name="license" class="skip" href="#license" title="link to this appendix"><img src="images/permalink.gif" alt="[link]" title="link to this appendix" width="8" height="9"></a> Terms of use</h2></div></div>
-<div></div>
-</div>
-<h3>
-<a name="id4953178" class="skip" href="#id4953178" title="link to this bridgehead"><img src="images/permalink.gif" alt="[link]" title="link to this bridgehead" width="8" height="9"></a> Software</h3>
-<p>The <span class="application">Universal Encoding Detector</span> library is copyright © 2006 Mark Pilgrim.  All rights reserved.</p>
-<p>Portions copyright © 1998-2001 Netscape Communications Corporation.  All rights reserved.</p>
-<p>The <span class="application">Universal Encoding Detector</span> library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.</p>
-<p>This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.</p>
-<p>You should have received a copy of the GNU Lesser General Public License along with this library (in a file named <tt class="literal">COPYING</tt>); if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA</p>
-<h3>
-<a name="id4953205" class="skip" href="#id4953205" title="link to this bridgehead"><img src="images/permalink.gif" alt="[link]" title="link to this bridgehead" width="8" height="9"></a> Documentation</h3>
-<p>The <span class="application">Universal Encoding Detector</span> documentation is copyright © 2006 Mark Pilgrim. All rights reserved.</p>
-<p>Redistribution and use in source (XML DocBook) and “<span class="quote">compiled</span>” forms (SGML, HTML, PDF, PostScript, RTF and so forth) with or without modification, are permitted provided that the following conditions are met:</p>
-<div class="orderedlist"><ol type="1">
-<li>Redistributions of source code (XML DocBook) must retain the above copyright notice, this list of conditions and the following disclaimer unmodified.</li>
-<li>Redistributions in compiled form (transformed to other DTDs, converted to PDF, PostScript, RTF and other formats) must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.</li>
-</ol></div>
-<p>THIS DOCUMENTATION IS PROVIDED BY THE AUTHOR “<span class="quote">AS IS</span>” AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS DOCUMENTATION, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</p>
-</div>
-<div class="footernavigation">
-<div style="float: left">← <a class="NavigationArrow" href="how-it-works.html">How it works</a>
-</div>
-<div style="text-align: right"></div>
-</div>
-<hr>
-<div id="footer"><p class="copyright">Copyright © 2006 Mark Pilgrim · <a href="mailto:mark@diveintomark.org">mark@diveintomark.org</a> · <a href="license.html">Terms of use</a></p></div>
-</div></div>
-</body>
-</html>
+<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
+<html lang="en">
+<head>
+<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
+<title>Terms of use [Universal Encoding Detector]</title>
+<link rel="stylesheet" href="css/chardet.css" type="text/css">
+<link rev="made" href="mailto:mark@diveintomark.org">
+<meta name="generator" content="DocBook XSL Stylesheets V1.65.1">
+<meta name="keywords" content="character, set, encoding, detection, Python, XML, feed">
+<link rel="start" href="index.html" title="Documentation">
+<link rel="up" href="index.html" title="Documentation">
+<link rel="prev" href="history.html" title="Revision history">
+</head>
+<body id="chardet-feedparser-org" class="docs">
+<div class="z" id="intro"><div class="sectionInner"><div class="sectionInner2">
+<div class="s" id="pageHeader">
+<h1><a href="/">Universal Encoding Detector</a></h1>
+<p>Character encoding auto-detection in Python.  As smart as your browser.  Open source.</p>
+</div>
+<div class="s" id="quickSummary"><ul>
+<li class="li1">
+<a href="http://chardet.feedparser.org/download/">Download</a> ·</li>
+<li class="li2">
+<a href="index.html">Documentation</a> ·</li>
+<li class="li3"><a href="faq.html" title="Frequently Asked Questions">FAQ</a></li>
+</ul></div>
+</div></div></div>
+<div id="main"><div id="mainInner">
+<p id="breadcrumb">You are here: <a href="index.html">Documentation</a> → <span class="thispage">Terms of use</span></p>
+<div class="appendix" lang="en">
+<div class="titlepage">
+<div><div><h2 class="title">
+<a name="license" class="skip" href="#license" title="link to this appendix"><img src="images/permalink.gif" alt="[link]" title="link to this appendix" width="8" height="9"></a> Terms of use</h2></div></div>
+<div></div>
+</div>
+<h3>
+<a name="id467047" class="skip" href="#id467047" title="link to this bridgehead"><img src="images/permalink.gif" alt="[link]" title="link to this bridgehead" width="8" height="9"></a> Software</h3>
+<p>The <span class="application">Universal Encoding Detector</span> library is copyright © 2006-2008 Mark Pilgrim.  All rights reserved.</p>
+<p>Portions copyright © 1998-2001 Netscape Communications Corporation.  All rights reserved.</p>
+<p>The <span class="application">Universal Encoding Detector</span> library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.</p>
+<p>This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.</p>
+<p>You should have received a copy of the GNU Lesser General Public License along with this library (in a file named <tt class="literal">COPYING</tt>); if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA</p>
+<h3>
+<a name="id467401" class="skip" href="#id467401" title="link to this bridgehead"><img src="images/permalink.gif" alt="[link]" title="link to this bridgehead" width="8" height="9"></a> Documentation</h3>
+<p>The <span class="application">Universal Encoding Detector</span> documentation is copyright © 2006-2008 Mark Pilgrim. All rights reserved.</p>
+<p>Redistribution and use in source (XML DocBook) and “<span class="quote">compiled</span>” forms (SGML, HTML, PDF, PostScript, RTF and so forth) with or without modification, are permitted provided that the following conditions are met:</p>
+<div class="orderedlist"><ol type="1">
+<li>Redistributions of source code (XML DocBook) must retain the above copyright notice, this list of conditions and the following disclaimer unmodified.</li>
+<li>Redistributions in compiled form (transformed to other DTDs, converted to PDF, PostScript, RTF and other formats) must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.</li>
+</ol></div>
+<p>THIS DOCUMENTATION IS PROVIDED BY THE AUTHOR “<span class="quote">AS IS</span>” AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS DOCUMENTATION, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</p>
+</div>
+<div class="footernavigation">
+<div style="float: left">← <a class="NavigationArrow" href="history.html">Revision history</a>
+</div>
+<div style="text-align: right"></div>
+</div>
+<hr>
+<div id="footer"><p class="copyright">Copyright © 2006, 2007, 2008 Mark Pilgrim · <a href="mailto:mark@diveintomark.org">mark@diveintomark.org</a> · <a href="license.html">Terms of use</a></p></div>
+</div></div>
+</body>
+</html>

=== modified file 'docs/supported-encodings.html'
--- docs/supported-encodings.html	2006-07-08 16:12:00 +0000
+++ docs/supported-encodings.html	2008-03-05 20:26:06 +0000
@@ -1,86 +1,86 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
-<html lang="en">
-<head>
-<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<title>Supported encodings [Universal Encoding Detector]</title>
-<link rel="stylesheet" href="css/chardet.css" type="text/css">
-<link rev="made" href="mailto:mark@diveintomark.org">
-<meta name="generator" content="DocBook XSL Stylesheets V1.65.1">
-<meta name="keywords" content="character, set, encoding, detection, Python, XML, feed">
-<link rel="start" href="index.html" title="Documentation">
-<link rel="up" href="index.html" title="Documentation">
-<link rel="prev" href="faq.html" title="Frequently asked questions">
-<link rel="next" href="usage.html" title="Usage">
-</head>
-<body id="chardet-feedparser-org" class="docs">
-<div class="z" id="intro"><div class="sectionInner"><div class="sectionInner2">
-<div class="s" id="pageHeader">
-<h1><a href="/">Universal Encoding Detector</a></h1>
-<p>Character encoding auto-detection in Python.  As smart as your browser.  Open source.</p>
-</div>
-<div class="s" id="quickSummary"><ul>
-<li class="li1">
-<a href="http://chardet.feedparser.org/download/">Download</a> ·</li>
-<li class="li2">
-<a href="index.html">Documentation</a> ·</li>
-<li class="li3"><a href="faq.html" title="Frequently Asked Questions">FAQ</a></li>
-</ul></div>
-</div></div></div>
-<div id="main"><div id="mainInner">
-<p id="breadcrumb">You are here: <a href="index.html">Documentation</a> → <span class="thispage">Supported encodings</span></p>
-<div class="section" lang="en">
-<div class="titlepage">
-<div>
-<div><h2 class="title">
-<a name="encodings" class="skip" href="#encodings" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Supported encodings</h2></div>
-<div><div class="abstract">
-<h3 class="title"></h3>
-<p><span class="application">Universal Encoding Detector</span> currently supports over two dozen character encodings.</p>
-</div></div>
-</div>
-<div></div>
-</div>
-<div class="itemizedlist"><ul>
-<li>
-<tt class="literal">Big5</tt>, <tt class="literal">GB2312</tt>/<tt class="literal">GB18030</tt>, <tt class="literal">EUC-TW</tt>, <tt class="literal">HZ-GB-2312</tt>, and <tt class="literal">ISO-2022-CN</tt> (Traditional and Simplified Chinese)</li>
-<li>
-<tt class="literal">EUC-JP</tt>, <tt class="literal">SHIFT_JIS</tt>, and <tt class="literal">ISO-2022-JP</tt> (Japanese)</li>
-<li>
-<tt class="literal">EUC-KR</tt> and <tt class="literal">ISO-2022-KR</tt> (Korean)</li>
-<li>
-<tt class="literal">KOI8-R</tt>, <tt class="literal">MacCyrillic</tt>, <tt class="literal">IBM855</tt>, <tt class="literal">IBM866</tt>, <tt class="literal">ISO-8859-5</tt>, and <tt class="literal">windows-1251</tt> (Russian)</li>
-<li>
-<tt class="literal">ISO-8859-2</tt> and <tt class="literal">windows-1250</tt> (Hungarian)</li>
-<li>
-<tt class="literal">ISO-8859-5</tt> and <tt class="literal">windows-1251</tt> (Bulgarian)</li>
-<li><tt class="literal">windows-1252</tt></li>
-<li>
-<tt class="literal">ISO-8859-7</tt> and <tt class="literal">windows-1253</tt> (Greek)</li>
-<li>
-<tt class="literal">ISO-8859-8</tt> and <tt class="literal">windows-1255</tt> (Visual and Logical Hebrew)</li>
-<li>
-<tt class="literal">TIS-620</tt> (Thai)</li>
-<li>
-<tt class="literal">UTF-32</tt> <acronym title="Big Endian">BE</acronym>, <acronym title="Little Endian">LE</acronym>, 3412-ordered, or 2143-ordered (with a <acronym title="Byte Order Mark">BOM</acronym>)</li>
-<li>
-<tt class="literal">UTF-16</tt> <acronym title="Big Endian">BE</acronym> or <acronym title="Little Endian">LE</acronym> (with a <acronym title="Byte Order Mark">BOM</acronym>)</li>
-<li>
-<tt class="literal">UTF-8</tt> (with or without a <acronym title="Byte Order Mark">BOM</acronym>)</li>
-<li><acronym>ASCII</acronym></li>
-</ul></div>
-<a name="id4897088"></a><table class="caution" border="0" summary="">
-<tr><td rowspan="2" align="center" valign="top" width="1%"><img src="images/caution.png" alt="Caution" title="" width="24" height="24"></td></tr>
-<tr><td colspan="2" align="left" valign="top" width="99%">Due to inherent similarities between certain encodings, some encodings may be detected incorrectly.  In my tests, the most problematic case was Hungarian text encoded as <tt class="literal">ISO-8859-2</tt> or <tt class="literal">windows-1250</tt> (encoded as one but reported as the other).  Also, Greek text encoded as <tt class="literal">ISO-8859-7</tt> was often mis-reported as <tt class="literal">ISO-8859-2</tt>.  Your mileage may vary.</td></tr>
-</table>
-</div>
-<div class="footernavigation">
-<div style="float: left">← <a class="NavigationArrow" href="faq.html">Frequently asked questions</a>
-</div>
-<div style="text-align: right">
-<a class="NavigationArrow" href="usage.html">Usage</a> →</div>
-</div>
-<hr>
-<div id="footer"><p class="copyright">Copyright © 2006 Mark Pilgrim · <a href="mailto:mark@diveintomark.org">mark@diveintomark.org</a> · <a href="license.html">Terms of use</a></p></div>
-</div></div>
-</body>
-</html>
+<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
+<html lang="en">
+<head>
+<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
+<title>Supported encodings [Universal Encoding Detector]</title>
+<link rel="stylesheet" href="css/chardet.css" type="text/css">
+<link rev="made" href="mailto:mark@diveintomark.org">
+<meta name="generator" content="DocBook XSL Stylesheets V1.65.1">
+<meta name="keywords" content="character, set, encoding, detection, Python, XML, feed">
+<link rel="start" href="index.html" title="Documentation">
+<link rel="up" href="index.html" title="Documentation">
+<link rel="prev" href="faq.html" title="Frequently asked questions">
+<link rel="next" href="usage.html" title="Usage">
+</head>
+<body id="chardet-feedparser-org" class="docs">
+<div class="z" id="intro"><div class="sectionInner"><div class="sectionInner2">
+<div class="s" id="pageHeader">
+<h1><a href="/">Universal Encoding Detector</a></h1>
+<p>Character encoding auto-detection in Python.  As smart as your browser.  Open source.</p>
+</div>
+<div class="s" id="quickSummary"><ul>
+<li class="li1">
+<a href="http://chardet.feedparser.org/download/">Download</a> ·</li>
+<li class="li2">
+<a href="index.html">Documentation</a> ·</li>
+<li class="li3"><a href="faq.html" title="Frequently Asked Questions">FAQ</a></li>
+</ul></div>
+</div></div></div>
+<div id="main"><div id="mainInner">
+<p id="breadcrumb">You are here: <a href="index.html">Documentation</a> → <span class="thispage">Supported encodings</span></p>
+<div class="section" lang="en">
+<div class="titlepage">
+<div>
+<div><h2 class="title">
+<a name="encodings" class="skip" href="#encodings" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Supported encodings</h2></div>
+<div><div class="abstract">
+<h3 class="title"></h3>
+<p><span class="application">Universal Encoding Detector</span> currently supports over two dozen character encodings.</p>
+</div></div>
+</div>
+<div></div>
+</div>
+<div class="itemizedlist"><ul>
+<li>
+<tt class="literal">Big5</tt>, <tt class="literal">GB2312</tt>/<tt class="literal">GB18030</tt>, <tt class="literal">EUC-TW</tt>, <tt class="literal">HZ-GB-2312</tt>, and <tt class="literal">ISO-2022-CN</tt> (Traditional and Simplified Chinese)</li>
+<li>
+<tt class="literal">EUC-JP</tt>, <tt class="literal">SHIFT_JIS</tt>, and <tt class="literal">ISO-2022-JP</tt> (Japanese)</li>
+<li>
+<tt class="literal">EUC-KR</tt> and <tt class="literal">ISO-2022-KR</tt> (Korean)</li>
+<li>
+<tt class="literal">KOI8-R</tt>, <tt class="literal">MacCyrillic</tt>, <tt class="literal">IBM855</tt>, <tt class="literal">IBM866</tt>, <tt class="literal">ISO-8859-5</tt>, and <tt class="literal">windows-1251</tt> (Russian)</li>
+<li>
+<tt class="literal">ISO-8859-2</tt> and <tt class="literal">windows-1250</tt> (Hungarian)</li>
+<li>
+<tt class="literal">ISO-8859-5</tt> and <tt class="literal">windows-1251</tt> (Bulgarian)</li>
+<li><tt class="literal">windows-1252</tt></li>
+<li>
+<tt class="literal">ISO-8859-7</tt> and <tt class="literal">windows-1253</tt> (Greek)</li>
+<li>
+<tt class="literal">ISO-8859-8</tt> and <tt class="literal">windows-1255</tt> (Visual and Logical Hebrew)</li>
+<li>
+<tt class="literal">TIS-620</tt> (Thai)</li>
+<li>
+<tt class="literal">UTF-32</tt> <acronym title="Big Endian">BE</acronym>, <acronym title="Little Endian">LE</acronym>, 3412-ordered, or 2143-ordered (with a <acronym title="Byte Order Mark">BOM</acronym>)</li>
+<li>
+<tt class="literal">UTF-16</tt> <acronym title="Big Endian">BE</acronym> or <acronym title="Little Endian">LE</acronym> (with a <acronym title="Byte Order Mark">BOM</acronym>)</li>
+<li>
+<tt class="literal">UTF-8</tt> (with or without a <acronym title="Byte Order Mark">BOM</acronym>)</li>
+<li><acronym>ASCII</acronym></li>
+</ul></div>
+<a name="id465955"></a><table class="caution" border="0" summary="">
+<tr><td rowspan="2" align="center" valign="top" width="1%"><img src="images/caution.png" alt="Caution" title="" width="24" height="24"></td></tr>
+<tr><td colspan="2" align="left" valign="top" width="99%">Due to inherent similarities between certain encodings, some encodings may be detected incorrectly.  In my tests, the most problematic case was Hungarian text encoded as <tt class="literal">ISO-8859-2</tt> or <tt class="literal">windows-1250</tt> (encoded as one but reported as the other).  Also, Greek text encoded as <tt class="literal">ISO-8859-7</tt> was often mis-reported as <tt class="literal">ISO-8859-2</tt>.  Your mileage may vary.</td></tr>
+</table>
+</div>
+<div class="footernavigation">
+<div style="float: left">← <a class="NavigationArrow" href="faq.html">Frequently asked questions</a>
+</div>
+<div style="text-align: right">
+<a class="NavigationArrow" href="usage.html">Usage</a> →</div>
+</div>
+<hr>
+<div id="footer"><p class="copyright">Copyright © 2006, 2007, 2008 Mark Pilgrim · <a href="mailto:mark@diveintomark.org">mark@diveintomark.org</a> · <a href="license.html">Terms of use</a></p></div>
+</div></div>
+</body>
+</html>

=== modified file 'docs/usage.html'
--- docs/usage.html	2006-07-08 16:12:00 +0000
+++ docs/usage.html	2008-03-05 20:26:06 +0000
@@ -1,107 +1,107 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
-<html lang="en">
-<head>
-<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<title>Usage [Universal Encoding Detector]</title>
-<link rel="stylesheet" href="css/chardet.css" type="text/css">
-<link rev="made" href="mailto:mark@diveintomark.org">
-<meta name="generator" content="DocBook XSL Stylesheets V1.65.1">
-<meta name="keywords" content="character, set, encoding, detection, Python, XML, feed">
-<link rel="start" href="index.html" title="Documentation">
-<link rel="up" href="index.html" title="Documentation">
-<link rel="prev" href="supported-encodings.html" title="Supported encodings">
-<link rel="next" href="how-it-works.html" title="How it works">
-</head>
-<body id="chardet-feedparser-org" class="docs">
-<div class="z" id="intro"><div class="sectionInner"><div class="sectionInner2">
-<div class="s" id="pageHeader">
-<h1><a href="/">Universal Encoding Detector</a></h1>
-<p>Character encoding auto-detection in Python.  As smart as your browser.  Open source.</p>
-</div>
-<div class="s" id="quickSummary"><ul>
-<li class="li1">
-<a href="http://chardet.feedparser.org/download/">Download</a> ·</li>
-<li class="li2">
-<a href="index.html">Documentation</a> ·</li>
-<li class="li3"><a href="faq.html" title="Frequently Asked Questions">FAQ</a></li>
-</ul></div>
-</div></div></div>
-<div id="main"><div id="mainInner">
-<p id="breadcrumb">You are here: <a href="index.html">Documentation</a> → <span class="thispage">Usage</span></p>
-<div class="section" lang="en">
-<div class="titlepage">
-<div><div><h2 class="title">
-<a name="usage" class="skip" href="#usage" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Usage</h2></div></div>
-<div></div>
-</div>
-<div class="section" lang="en">
-<div class="titlepage">
-<div><div><h3 class="title">
-<a name="usage.basic" class="skip" href="#usage.basic" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Basic usage</h3></div></div>
-<div></div>
-</div>
-<p>The easiest way to use the <span class="application">Universal Encoding Detector</span> library is with the <tt class="function">detect</tt> function.</p>
-<div class="example">
-<a name="example.basic.detect" class="skip" href="#example.basic.detect" title="link to this example"><img src="images/permalink.gif" alt="[link]" title="link to this example" width="8" height="9"></a> <h3 class="title">Example: Using the <tt class="function">detect</tt> function</h3>
-<p>The <tt class="function">detect</tt> function takes one argument, a non-Unicode string.  It returns a dictionary containing the auto-detected character encoding and a confidence level from <tt class="constant">0</tt> to <tt class="constant">1</tt>.</p>
-<pre class="screen"><tt class="prompt">&gt;&gt;&gt; </tt><span class="userinput"><font color='navy'><b>import</b></font> urllib</span>
-<tt class="prompt">&gt;&gt;&gt; </tt><span class="userinput">rawdata = urllib.urlopen(<font color='olive'>'http://yahoo.co.jp/'</font>).read()</span>
-<tt class="prompt">&gt;&gt;&gt; </tt><span class="userinput"><font color='navy'><b>import</b></font> chardet</span>
-<tt class="prompt">&gt;&gt;&gt; </tt><span class="userinput">chardet.detect(rawdata)</span>
-<span class="computeroutput">{'encoding': 'EUC-JP', 'confidence': 0.99}</span></pre>
-</div>
-</div>
-<div class="section" lang="en">
-<div class="titlepage">
-<div><div><h3 class="title">
-<a name="usage.advanced" class="skip" href="#usage.advanced" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Advanced usage</h3></div></div>
-<div></div>
-</div>
-<p>If you're dealing with a large amount of text, you can call the <span class="application">Universal Encoding Detector</span> library incrementally, and it will stop as soon as it is confident enough to report its results.</p>
-<p>Create a <tt class="classname">UniversalDetector</tt> object, then call its <tt class="methodname">feed</tt> method repeatedly with each block of text.  If the detector reaches a minimum threshold of confidence, it will set <tt class="varname">detector.done</tt> to <tt class="constant">True</tt>.</p>
-<p>Once you've exhausted the source text, call <tt class="methodname">detector.close()</tt>, which will do some final calculations in case the detector didn't hit its minimum confidence threshold earlier.  Then <tt class="varname">detector.result</tt> will be a dictionary containing the auto-detected character encoding and confidence level (the same as <a href="usage.html#example.basic.detect" title="Example: Using the detect function">the <tt class="function">chardet.detect</tt> function returns</a>).</p>
-<div class="example">
-<a name="example.multiline" class="skip" href="#example.multiline" title="link to this example"><img src="images/permalink.gif" alt="[link]" title="link to this example" width="8" height="9"></a> <h3 class="title">Example: Detecting encoding incrementally</h3>
-<pre class="programlisting python"><font color='navy'><b>import</b></font> urllib
-<font color='navy'><b>from</b></font> chardet.universaldetector <font color='navy'><b>import</b></font> UniversalDetector
-
-usock = urllib.urlopen(<font color='olive'>'http://yahoo.co.jp/'</font>)
-detector = UniversalDetector()
-<font color='navy'><b>for</b></font> line <font color='navy'><b>in</b></font> usock.readlines():
-    detector.feed(line)
-    <font color='navy'><b>if</b></font> detector.done: <font color='navy'><b>break</b></font>
-detector.close()
-usock.close()
-<font color='navy'><b>print</b></font> detector.result</pre>
-<pre class="screen"><span class="computeroutput">{'encoding': 'EUC-JP', 'confidence': 0.99}</span></pre>
-</div>
-<p>If you want to detect the encoding of multiple texts (such as separate files), you can re-use a single <tt class="classname">UniversalDetector</tt> object.  Just call <tt class="methodname">detector.reset()</tt> at the start of each file, call <tt class="methodname">detector.feed</tt> as many times as you like, and then call <tt class="methodname">detector.close()</tt> and check the <tt class="varname">detector.result</tt> dictionary for the file's results.</p>
-<div class="example">
-<a name="advanced.multifile.multiline" class="skip" href="#advanced.multifile.multiline" title="link to this example"><img src="images/permalink.gif" alt="[link]" title="link to this example" width="8" height="9"></a> <h3 class="title">Example: Detecting encodings of multiple files</h3>
-<pre class="programlisting python"><font color='navy'><b>import</b></font> glob
-<font color='navy'><b>from</b></font> charset.universaldetector <font color='navy'><b>import</b></font> UniversalDetector
-
-detector = UniversalDetector()
-<font color='navy'><b>for</b></font> filename <font color='navy'><b>in</b></font> glob.glob(<font color='olive'>'*.xml'</font>):
-    <font color='navy'><b>print</b></font> filename.ljust(60),
-    detector.reset()
-    <font color='navy'><b>for</b></font> line <font color='navy'><b>in</b></font> file(filename, <font color='olive'>'rb'</font>):
-        detector.feed(line)
-        <font color='navy'><b>if</b></font> detector.done: <font color='navy'><b>break</b></font>
-    detector.close()
-    <font color='navy'><b>print</b></font> detector.result
-</pre>
-</div>
-</div>
-</div>
-<div class="footernavigation">
-<div style="float: left">← <a class="NavigationArrow" href="supported-encodings.html">Supported encodings</a>
-</div>
-<div style="text-align: right">
-<a class="NavigationArrow" href="how-it-works.html">How it works</a> →</div>
-</div>
-<hr>
-<div id="footer"><p class="copyright">Copyright © 2006 Mark Pilgrim · <a href="mailto:mark@diveintomark.org">mark@diveintomark.org</a> · <a href="license.html">Terms of use</a></p></div>
-</div></div>
-</body>
-</html>
+<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
+<html lang="en">
+<head>
+<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
+<title>Usage [Universal Encoding Detector]</title>
+<link rel="stylesheet" href="css/chardet.css" type="text/css">
+<link rev="made" href="mailto:mark@diveintomark.org">
+<meta name="generator" content="DocBook XSL Stylesheets V1.65.1">
+<meta name="keywords" content="character, set, encoding, detection, Python, XML, feed">
+<link rel="start" href="index.html" title="Documentation">
+<link rel="up" href="index.html" title="Documentation">
+<link rel="prev" href="supported-encodings.html" title="Supported encodings">
+<link rel="next" href="how-it-works.html" title="How it works">
+</head>
+<body id="chardet-feedparser-org" class="docs">
+<div class="z" id="intro"><div class="sectionInner"><div class="sectionInner2">
+<div class="s" id="pageHeader">
+<h1><a href="/">Universal Encoding Detector</a></h1>
+<p>Character encoding auto-detection in Python.  As smart as your browser.  Open source.</p>
+</div>
+<div class="s" id="quickSummary"><ul>
+<li class="li1">
+<a href="http://chardet.feedparser.org/download/">Download</a> ·</li>
+<li class="li2">
+<a href="index.html">Documentation</a> ·</li>
+<li class="li3"><a href="faq.html" title="Frequently Asked Questions">FAQ</a></li>
+</ul></div>
+</div></div></div>
+<div id="main"><div id="mainInner">
+<p id="breadcrumb">You are here: <a href="index.html">Documentation</a> → <span class="thispage">Usage</span></p>
+<div class="section" lang="en">
+<div class="titlepage">
+<div><div><h2 class="title">
+<a name="usage" class="skip" href="#usage" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Usage</h2></div></div>
+<div></div>
+</div>
+<div class="section" lang="en">
+<div class="titlepage">
+<div><div><h3 class="title">
+<a name="usage.basic" class="skip" href="#usage.basic" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Basic usage</h3></div></div>
+<div></div>
+</div>
+<p>The easiest way to use the <span class="application">Universal Encoding Detector</span> library is with the <tt class="function">detect</tt> function.</p>
+<div class="example">
+<a name="example.basic.detect" class="skip" href="#example.basic.detect" title="link to this example"><img src="images/permalink.gif" alt="[link]" title="link to this example" width="8" height="9"></a> <h3 class="title">Example: Using the <tt class="function">detect</tt> function</h3>
+<p>The <tt class="function">detect</tt> function takes one argument, a non-Unicode string.  It returns a dictionary containing the auto-detected character encoding and a confidence level from <tt class="constant">0</tt> to <tt class="constant">1</tt>.</p>
+<pre class="screen"><tt class="prompt">&gt;&gt;&gt; </tt><span class="userinput"><font color='navy'><b>import</b></font> urllib</span>
+<tt class="prompt">&gt;&gt;&gt; </tt><span class="userinput">rawdata = urllib.urlopen(<font color='olive'>'http://yahoo.co.jp/'</font>).read()</span>
+<tt class="prompt">&gt;&gt;&gt; </tt><span class="userinput"><font color='navy'><b>import</b></font> chardet</span>
+<tt class="prompt">&gt;&gt;&gt; </tt><span class="userinput">chardet.detect(rawdata)</span>
+<span class="computeroutput">{'encoding': 'EUC-JP', 'confidence': 0.99}</span></pre>
+</div>
+</div>
+<div class="section" lang="en">
+<div class="titlepage">
+<div><div><h3 class="title">
+<a name="usage.advanced" class="skip" href="#usage.advanced" title="link to this section"><img src="images/permalink.gif" alt="[link]" title="link to this section" width="8" height="9"></a> Advanced usage</h3></div></div>
+<div></div>
+</div>
+<p>If you're dealing with a large amount of text, you can call the <span class="application">Universal Encoding Detector</span> library incrementally, and it will stop as soon as it is confident enough to report its results.</p>
+<p>Create a <tt class="classname">UniversalDetector</tt> object, then call its <tt class="methodname">feed</tt> method repeatedly with each block of text.  If the detector reaches a minimum threshold of confidence, it will set <tt class="varname">detector.done</tt> to <tt class="constant">True</tt>.</p>
+<p>Once you've exhausted the source text, call <tt class="methodname">detector.close()</tt>, which will do some final calculations in case the detector didn't hit its minimum confidence threshold earlier.  Then <tt class="varname">detector.result</tt> will be a dictionary containing the auto-detected character encoding and confidence level (the same as <a href="usage.html#example.basic.detect" title="Example: Using the detect function">the <tt class="function">chardet.detect</tt> function returns</a>).</p>
+<div class="example">
+<a name="example.multiline" class="skip" href="#example.multiline" title="link to this example"><img src="images/permalink.gif" alt="[link]" title="link to this example" width="8" height="9"></a> <h3 class="title">Example: Detecting encoding incrementally</h3>
+<pre class="programlisting python"><font color='navy'><b>import</b></font> urllib
+<font color='navy'><b>from</b></font> chardet.universaldetector <font color='navy'><b>import</b></font> UniversalDetector
+
+usock = urllib.urlopen(<font color='olive'>'http://yahoo.co.jp/'</font>)
+detector = UniversalDetector()
+<font color='navy'><b>for</b></font> line <font color='navy'><b>in</b></font> usock.readlines():
+    detector.feed(line)
+    <font color='navy'><b>if</b></font> detector.done: <font color='navy'><b>break</b></font>
+detector.close()
+usock.close()
+<font color='navy'><b>print</b></font> detector.result</pre>
+<pre class="screen"><span class="computeroutput">{'encoding': 'EUC-JP', 'confidence': 0.99}</span></pre>
+</div>
+<p>If you want to detect the encoding of multiple texts (such as separate files), you can re-use a single <tt class="classname">UniversalDetector</tt> object.  Just call <tt class="methodname">detector.reset()</tt> at the start of each file, call <tt class="methodname">detector.feed</tt> as many times as you like, and then call <tt class="methodname">detector.close()</tt> and check the <tt class="varname">detector.result</tt> dictionary for the file's results.</p>
+<div class="example">
+<a name="advanced.multifile.multiline" class="skip" href="#advanced.multifile.multiline" title="link to this example"><img src="images/permalink.gif" alt="[link]" title="link to this example" width="8" height="9"></a> <h3 class="title">Example: Detecting encodings of multiple files</h3>
+<pre class="programlisting python"><font color='navy'><b>import</b></font> glob
+<font color='navy'><b>from</b></font> charset.universaldetector <font color='navy'><b>import</b></font> UniversalDetector
+
+detector = UniversalDetector()
+<font color='navy'><b>for</b></font> filename <font color='navy'><b>in</b></font> glob.glob(<font color='olive'>'*.xml'</font>):
+    <font color='navy'><b>print</b></font> filename.ljust(60),
+    detector.reset()
+    <font color='navy'><b>for</b></font> line <font color='navy'><b>in</b></font> file(filename, <font color='olive'>'rb'</font>):
+        detector.feed(line)
+        <font color='navy'><b>if</b></font> detector.done: <font color='navy'><b>break</b></font>
+    detector.close()
+    <font color='navy'><b>print</b></font> detector.result
+</pre>
+</div>
+</div>
+</div>
+<div class="footernavigation">
+<div style="float: left">← <a class="NavigationArrow" href="supported-encodings.html">Supported encodings</a>
+</div>
+<div style="text-align: right">
+<a class="NavigationArrow" href="how-it-works.html">How it works</a> →</div>
+</div>
+<hr>
+<div id="footer"><p class="copyright">Copyright © 2006, 2007, 2008 Mark Pilgrim · <a href="mailto:mark@diveintomark.org">mark@diveintomark.org</a> · <a href="license.html">Terms of use</a></p></div>
+</div></div>
+</body>
+</html>

=== modified file 'setup.py'
--- setup.py	2006-07-08 16:12:00 +0000
+++ setup.py	2008-03-05 20:26:06 +0000
@@ -10,7 +10,7 @@
     
 setup(
     name = 'chardet',
-    version = '1.0',
+    version = '1.0.1',
     description = 'Universal encoding detector',
     long_description = """\
 Universal character encoding detector

